if (!Object.getOwnPropertyDescriptor) {

	Object.getOwnPropertyDescriptor = function getOwnPropertyDescriptor(object, property) {
	if (Object(object) !== object) 
		{
			throw new TypeError('Object.getOwnPropertyDescriptor can only be called on Objects.');
		}

	var descriptor;
	if(!Object.prototype.hasOwnProperty.call(object, property))
		{
			return descriptor;
		}

    descriptor = {
        enumerable: Object.prototype.propertyIsEnumerable.call(object, property),
        configurable: true
    };

    descriptor.value = object[property];

    var psPropertyType = object.reflect.find(property).type;
	descriptor.writable = (psPropertyType === "readwrite");

    return descriptor;
	}
}